//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Ruler.h"
//---------------------------------------------------------------------------
static inline TRuler *ValidCtrCheck()
{
   return new TRuler(NULL);
}
//---------------------------------------------------------------------------
__fastcall TRuler::TRuler(TComponent* Owner)
   : TCustomPanel(Owner)
{
   Caption = "";
   RulerDetails = 8;
   ZeroPozition = 0;
   PixelsByUnit = 32;
   RulerType = rtHorz;
   SmallHeight = 5;
   HalfHeight = 10;
   FullHeight = 15;
   RulerStep = 1;
}
//---------------------------------------------------------------------------
namespace Ruler
{
   void __fastcall Register()
   {
       TComponentClass classes[1] = {__classid(TRuler)};
       RegisterComponents("Samples", classes, 0);
   }
}
//---------------------------------------------------------------------------
void __fastcall TRuler::Paint(void)
{
   inherited::Paint();
   // inherited::Paint() can change Canvas's Pen color
   Canvas->Pen->Color = Font->Color;
   TRect rect = ClientRect;
   rect.Left += BevelWidth;
   rect.Top += BevelWidth;
   rect.Right -= BevelWidth + 1;
   rect.Bottom -= BevelWidth + 1;
   // custom ruler draw
   if( RulerType == rtHorz)
   {  // horizontal ruler
      int x = - ZeroPozition * RulerDetails / PixelsByUnit;
      for(  int pos;
            ( pos = x * PixelsByUnit / RulerDetails + ZeroPozition + BevelWidth ) < rect.Right;
            x++)
      {
         Canvas->MoveTo( pos, rect.Bottom);
         Word height = SmallHeight;
         if( !( x % RulerDetails)){
            height = FullHeight;
         }
         else if( !( x % ( RulerDetails / 2))){
            height = HalfHeight;
         }
         Canvas->LineTo( pos, rect.Bottom - height);
         if( !( x % RulerDetails))
            Canvas->TextRect( rect, pos + 1, rect.Bottom - height - 4,
                             RulerStep * x / RulerDetails);
      }
   }
   else
   {  // vertical ruler
      int y = - ZeroPozition * RulerDetails / PixelsByUnit;
      for(  int pos;
            ( pos = y * PixelsByUnit / RulerDetails + ZeroPozition + BevelWidth ) < rect.Bottom;
            y++)
      {
         Canvas->MoveTo( rect.Right, pos);
         Word height = SmallHeight;
         if( !( y % RulerDetails)){
            height = FullHeight;
         }
         else if( !( y % ( RulerDetails / 2))){
            height = HalfHeight;
         }
         Canvas->LineTo( rect.Right - height, pos);
         if( !( y % RulerDetails))
            Canvas->TextRect( rect, rect.Right - height - 4,
                             pos + 1, RulerStep * y / RulerDetails);
      }
   }
   return;
}

void __fastcall TRuler::SetRulerProperty( int index, Word set)
{
   switch( index){
      case rpPixelsByUnit: FPixelsByUnit  = set; break;
      case rpRulerDetails: FRulerDetails  = set + set % 2; break;
      case rpSmallHeight:  FSmallHeight   = set; break;
      case rpHalfHeight:   FHalfHeight    = set; break;
      case rpFullHeight:   FFullHeight    = set; break;
      case rpRulerStep:    FRulerStep     = set; break;
      default: return;
   }
   Invalidate();
   return;
}

void __fastcall TRuler::SetRulerType( TRulerType set)
{
   FRulerType = set;
   Invalidate();
   return;
}

void __fastcall TRuler::SetZeroPozition( int set)
{
   FZeroPozition = set;
   Invalidate();
   return;
}

double __fastcall TRuler::MouseToUnit( void)
{
   POINT mouse;
   ::GetCursorPos( &mouse);
   ::ScreenToClient( Handle, &mouse);
   double value = ( RulerType == rtHorz ? mouse.x : mouse.y ) - BevelWidth;
   return - ( ZeroPozition - value) * RulerStep / PixelsByUnit;
}
