//---------------------------------------------------------------------------
#ifndef TRulerH
#define TRulerH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------

// ruler can be horizontal or vertical
enum TRulerType { rtHorz, rtVert };
enum RulerProperty { rpPixelsByUnit, rpRulerDetails, rpSmallHeight,
                     rpHalfHeight, rpFullHeight, rpRulerStep};

class TRuler : public TCustomPanel
{
	typedef TCustomPanel inherited;
private:
   TRulerType FRulerType;
   int FZeroPozition;
   Word FPixelsByUnit;
   Word FRulerDetails;
   Word FSmallHeight;
   Word FHalfHeight;
   Word FFullHeight;
   Word FRulerStep;

protected:
   virtual void __fastcall Paint(void);
   void __fastcall SetRulerType( TRulerType set);
   void __fastcall SetZeroPozition( int set);
   void __fastcall SetRulerProperty( int index, Word set);

public:
   __fastcall TRuler(TComponent* Owner);
   double __fastcall MouseToUnit( void);

__published:

   // ruler specific property
   __property TRulerType RulerType = { read = FRulerType,
         write = SetRulerType};
   __property int ZeroPozition = { read = FZeroPozition,
      write = SetZeroPozition};
   __property Word PixelsByUnit = { read = FPixelsByUnit,
      write = SetRulerProperty, index = rpPixelsByUnit};
   __property Word RulerDetails = { read = FRulerDetails,
      write = SetRulerProperty, index = rpRulerDetails};
   __property Word SmallHeight = { read = FSmallHeight,
      write = SetRulerProperty, index = rpSmallHeight};
   __property Word HalfHeight = { read = FHalfHeight,
      write = SetRulerProperty, index = rpHalfHeight};
   __property Word FullHeight = { read = FFullHeight,
      write = SetRulerProperty, index = rpFullHeight};
   __property Word RulerStep = { read = FRulerStep,
      write = SetRulerProperty, index = rpRulerStep};

	__property Align ;
	__property Alignment ;
	__property BevelInner ;
	__property BevelOuter ;
	__property BevelWidth ;
	__property BorderWidth ;
	__property BorderStyle ;
	__property DragCursor ;
	__property DragMode ;
	__property Enabled ;
	//__property Caption ;
	__property Color ;
	__property Ctl3D ;
	__property Font ;
	__property Locked ;
	__property ParentColor ;
	__property ParentCtl3D ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property TabOrder ;
	__property TabStop ;
	__property Visible ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnResize ;
	__property OnStartDrag ;
};
//---------------------------------------------------------------------------
#endif

